=== debian/changelog ===
iscsitarget (1.4.20.3+svn499-0ubuntu2.6) trusty; urgency=medium

  * Fix ADT requirements to run daemon test only when isolation
    level machine is available.

 -- Stefan Bader <stefan.bader@canonical.com>  Mon, 28 Jan 2019 11:16:06 +0100

iscsitarget (1.4.20.3+svn499-0ubuntu2.5) trusty; urgency=medium

  * Fix daemon dep8 test so it really tests for the running
    daemon (LP: #1734855).

 -- Stefan Bader <stefan.bader@canonical.com>  Thu, 01 Feb 2018 16:48:03 +0100

iscsitarget (1.4.20.3+svn499-0ubuntu2.4) trusty; urgency=medium

  * Remove compat code for 4.4.0-84 and detect sock_recvmsg signature
    during build. (LP: #1732746)

 -- Thadeu Lima de Souza Cascardo <cascardo@canonical.com>  Fri, 17 Nov 2017 17:47:16 +0000

iscsitarget (1.4.20.3+svn499-0ubuntu2.3) trusty; urgency=medium

  * d/p/(porting|compat|enable)-4.4.0-84.patch:
    Add compat code to build with Ubuntu 4.4.0-84 (LP: #1701697)
  
 -- Thadeu Lima de Souza Cascardo <cascardo@canonical.com>  Wed, 12 Jul 2017 20:13:41 +0000

iscsitarget (1.4.20.3+svn499-0ubuntu2.2) trusty; urgency=medium

  * Backport compat changes to allow DKMS compiles for kernels up to 4.4
    (LP: #1612627).
    - d/p/fix-build-4.3.patch: Fix source to compile with 4.3+
      kernels.  Thanks to Stefan Bader <stefan.bader@canonical.com>.
    - d/p/add-4.3-compat.patch: Add compat-4.3.patch to DKMS patches.
      Thanks to Stefan Bader <stefan.bader@canonical.com>.
    - d/p/enable-4.3-compat.patch: Enable compat-4.3 patch for DKMS
      builds.  Thanks to Stefan Bader <stefan.bader@canonical.com>.

 -- Nishanth Aravamudan <nish.aravamudan@canonical.com>  Mon, 20 Mar 2017 17:07:43 -0700
