=== debian/rules ===
--- 
+++ 
@@ -67,6 +67,10 @@
 kver_ge = $(shell [ $(KMAJ)$(KMIN)$(KREV) -ge $(1)$(2)$(3) ] && \
 	echo 1 || echo 0)
 kver_lk = $(shell [ `echo $(KERN_VER) | egrep $(1)` ] && echo 1 || echo 0)
+
+ifeq ($(call kver_lt,3,13,0),1)
+    PATCHES := $(PATCHES) compat-3.12.patch
+endif
 
 ifeq ($(call kver_lt,3,10,0),1)
     PATCHES := $(PATCHES) compat-3.9.patch
@@ -241,6 +245,10 @@
 	cp kernel/*  debian/$(pdkms)/usr/src/$(PACKAGE)-$(DEB_UPSTREAM_VERSION)/kernel/
 	cp include/* debian/$(pdkms)/usr/src/$(PACKAGE)-$(DEB_UPSTREAM_VERSION)/include/
 	cp patches/* debian/$(pdkms)/usr/src/$(PACKAGE)-$(DEB_UPSTREAM_VERSION)/patches/
+
+	# Copy prebuild script
+	install -m 755 debian/configure_features.sh \
+		debian/$(pdkms)/usr/src/$(PACKAGE)-$(DEB_UPSTREAM_VERSION)/
 	
 	# Copy the needed debian/ pieces to the proper location
 	cp debian/*-module-* \
@@ -259,6 +267,3 @@
 	cd debian ; cp changelog control compat *.modules.in rules copyright $(pdkms)/usr/src/$(PACKAGE)-$(DEB_UPSTREAM_VERSION)/debian
 	
 	# create toplevel module Makefile
-	echo "obj-m = kernel/" > debian/$(pdkms)/usr/src/$(PACKAGE)-$(DEB_UPSTREAM_VERSION)/Makefile
-	
-	# Prepare dkms.conf from the dkms.conf.in template
