=== debian/tests/control ===
Test-Command: modprobe iscsi_trgt
Depends: iscsitarget, iscsitarget-dkms
Restrictions: needs-root, isolation-machine

Tests: daemon
Depends: iscsitarget, iscsitarget-dkms
Restrictions: needs-root, isolation-machine
