=== debian/watch ===
version=3
http://sf.net/iscsitarget/iscsitarget-(.+)\.tar\.gz
