## iscsitarget 1.4.20.3+svn502

=== Makefile ===
--- 
+++ 
@@ -66,6 +66,10 @@
 # base first the earlier patch sets will not need to be modified.
 #
 
+ifeq ($(call kver_lt,3,14,0),1)
+	PATCHES := $(PATCHES) compat-3.13.patch
+endif
+
 ifeq ($(call kver_lt,3,13,0),1)
 	PATCHES := $(PATCHES) compat-3.12.patch
 endif
