=== debian/changelog ===
iscsitarget (1.4.20.3+svn502-2) unstable; urgency=medium

  * [b17e4aa] Add patch to extend dkms buils in chroot environments.
    Thanks to Philipp Hahn (Closes: #766989)

 -- Ritesh Raj Sarraf <rrs@debian.org>  Tue, 28 Oct 2014 15:44:22 +0530

iscsitarget (1.4.20.3+svn502-1) unstable; urgency=medium

  * [f81dcec] Imported Upstream version 1.4.20.3+svn502
    Closes: #746821
  * [cdf7cbd] Fix Vcs links

 -- Ritesh Raj Sarraf <rrs@debian.org>  Thu, 08 May 2014 18:38:46 +0530
