=== debian/control ===
--- 
+++ 
@@ -1,15 +1,13 @@
 Source: iscsitarget
 Section: net
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian iSCSI Maintainers <pkg-iscsi-maintainers@lists.alioth.debian.org>
+Maintainer: Debian iSCSI Maintainers <pkg-iscsi-maintainers@lists.alioth.debian.org>
 Uploaders: Philipp Hug <debian@hug.cx>, Guido Guenther <agx@sigxcpu.org>, Frederik Schüler <fs@debian.org>, Ritesh Raj Sarraf <rrs@debian.org>
-Build-Depends: debhelper (>= 5.0.0), libssl-dev, bzip2
+Build-Depends: debhelper (>= 5.0.0), libssl-dev, bzip2, dkms
 Standards-Version: 3.9.2
 Homepage: http://iscsitarget.sourceforge.net/
-Vcs-Git: git://git.debian.org/git/pkg-iscsi/iscsitarget.git
-Vcs-Browser: http://git.debian.org/?p=pkg-iscsi/iscsitarget.git
-XS-Testsuite: autopkgtest
+Vcs-Git: git://anonscm.debian.org/pkg-iscsi/iscsitarget.git
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-iscsi/iscsitarget.git
 
 Package: iscsitarget
 Architecture: any
