=== debian/rules ===
--- 
+++ 
@@ -67,38 +67,6 @@
 kver_ge = $(shell [ $(KMAJ)$(KMIN)$(KREV) -ge $(1)$(2)$(3) ] && \
 	echo 1 || echo 0)
 kver_lk = $(shell [ `echo $(KERN_VER) | egrep $(1)` ] && echo 1 || echo 0)
-
-ifeq ($(call kver_lt,3,13,0),1)
-    PATCHES := $(PATCHES) compat-3.12.patch
-endif
-
-ifeq ($(call kver_lt,3,10,0),1)
-    PATCHES := $(PATCHES) compat-3.9.patch
-endif
-
-ifeq ($(call kver_lt,3,7,0),1)
-    PATCHES := $(PATCHES) compat-3.6.patch
-endif
-
-ifeq ($(call kver_le,3,5,0),1)
-    PATCHES := $(PATCHES) compat-3.5.patch
-endif
-
-ifeq ($(call kver_le,3,4,0),1)
-    PATCHES := $(PATCHES) compat-3.2-3.4.patch
-endif
-
-ifeq ($(call kver_le,3,2,0),1)
-    PATCHES := $(PATCHES) compat-2.6.39-3.2.patch
-endif
-
-ifeq ($(call kver_le,2,6,38),1)
-    PATCHES := $(PATCHES) compat-2.6.38.patch
-endif
-
-ifeq ($(call kver_le,2,6,37),1)
-    PATCHES := $(PATCHES) compat-2.6.36-2.6.37.patch
-endif
 
 # Compatibility patch for kernels >= 2.6.36  <= 2.6.38
 ifeq ($(call kver_le,2,6,38),1)
@@ -245,10 +213,6 @@
 	cp kernel/*  debian/$(pdkms)/usr/src/$(PACKAGE)-$(DEB_UPSTREAM_VERSION)/kernel/
 	cp include/* debian/$(pdkms)/usr/src/$(PACKAGE)-$(DEB_UPSTREAM_VERSION)/include/
 	cp patches/* debian/$(pdkms)/usr/src/$(PACKAGE)-$(DEB_UPSTREAM_VERSION)/patches/
-
-	# Copy prebuild script
-	install -m 755 debian/configure_features.sh \
-		debian/$(pdkms)/usr/src/$(PACKAGE)-$(DEB_UPSTREAM_VERSION)/
 	
 	# Copy the needed debian/ pieces to the proper location
 	cp debian/*-module-* \
@@ -267,3 +231,37 @@
 	cd debian ; cp changelog control compat *.modules.in rules copyright $(pdkms)/usr/src/$(PACKAGE)-$(DEB_UPSTREAM_VERSION)/debian
 	
 	# create toplevel module Makefile
+	echo "obj-m = kernel/" > debian/$(pdkms)/usr/src/$(PACKAGE)-$(DEB_UPSTREAM_VERSION)/Makefile
+	
+	# Prepare dkms.conf from the dkms.conf.in template
+	sed "s/__VERSION__/$(DEB_UPSTREAM_VERSION)/g" debian/dkms.conf.in > debian/dkms.conf
+	grep ^PATCH dkms.conf >> debian/dkms.conf
+	dh_dkms -p$(pdkms) -- debian/dkms.conf
+
+	dh_install -i
+
+install-arch:
+	dh_testdir
+	dh_testroot
+	dh_clean -k -s 
+	dh_installdirs -s
+	dh_install -s
+	
+	# install override
+	mkdir -p debian/iscsitarget/usr/share/lintian/overrides
+	cp debian/iscsitarget.overrides \
+		debian/iscsitarget/usr/share/lintian/overrides/iscsitarget
+
+# Must not depend on anything. This is to be called by
+# binary-arch/binary-indep
+# in another 'make' thread.
+binary-common:
+	dh_testdir
+	dh_testroot
+	dh_installchangelogs ChangeLog
+	dh_installdocs
+	dh_installinit
+	dh_installman
+	dh_link
+	dh_strip
+	dh_compress
